diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-customize-setting.php ./wordpress-3.4/wp-includes/class-wp-customize-setting.php
*** ./wordpress-3.3.2/wp-includes/class-wp-customize-setting.php	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/class-wp-customize-setting.php	2012-06-11 15:49:45.000000000 -0500
***************
*** 0 ****
--- 1,409 ----
+ <?php
+ /**
+  * Customize Setting Class
+  *
+  * @package WordPress
+  * @subpackage Customize
+  * @since 3.4.0
+  */
+ 
+ class WP_Customize_Setting {
+ 	public $manager;
+ 	public $id;
+ 
+ 	public $type            = 'theme_mod';
+ 	public $capability      = 'edit_theme_options';
+ 	public $theme_supports  = '';
+ 	public $default         = '';
+ 	public $transport       = 'refresh';
+ 
+ 	public $sanitize_callback    = '';
+ 	public $sanitize_js_callback = '';
+ 
+ 	protected $id_data = array();
+ 	private $_post_value; // Cached, sanitized $_POST value.
+ 
+ 	/**
+ 	 * Constructor.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param string $id An specific ID of the setting. Can be a
+ 	 *                   theme mod or option name.
+ 	 * @param array $args Setting arguments.
+ 	 */
+ 	function __construct( $manager, $id, $args = array() ) {
+ 		$keys = array_keys( get_class_vars( __CLASS__ ) );
+ 		foreach ( $keys as $key ) {
+ 			if ( isset( $args[ $key ] ) )
+ 				$this->$key = $args[ $key ];
+ 		}
+ 
+ 		$this->manager = $manager;
+ 		$this->id = $id;
+ 
+ 		// Parse the ID for array keys.
+ 		$this->id_data[ 'keys' ] = preg_split( '/\[/', str_replace( ']', '', $this->id ) );
+ 		$this->id_data[ 'base' ] = array_shift( $this->id_data[ 'keys' ] );
+ 
+ 		// Rebuild the ID.
+ 		$this->id = $this->id_data[ 'base' ];
+ 		if ( ! empty( $this->id_data[ 'keys' ] ) )
+ 			$this->id .= '[' . implode( '][', $this->id_data[ 'keys' ] ) . ']';
+ 
+ 		if ( $this->sanitize_callback )
+ 			add_filter( "customize_sanitize_{$this->id}", $this->sanitize_callback, 10, 2 );
+ 
+ 		if ( $this->sanitize_js_callback )
+ 			add_filter( "customize_sanitize_js_{$this->id}", $this->sanitize_js_callback, 10, 2 );
+ 
+ 		return $this;
+ 	}
+ 
+ 	/**
+ 	 * Handle previewing the setting.
+ 	 *
+ 	 * @since 3.4.0
+ 	 */
+ 	public function preview() {
+ 		switch( $this->type ) {
+ 			case 'theme_mod' :
+ 				add_filter( 'theme_mod_' . $this->id_data[ 'base' ], array( $this, '_preview_filter' ) );
+ 				break;
+ 			case 'option' :
+ 				if ( empty( $this->id_data[ 'keys' ] ) )
+ 					add_filter( 'pre_option_' . $this->id_data[ 'base' ], array( $this, '_preview_filter' ) );
+ 				else {
+ 					add_filter( 'option_' . $this->id_data[ 'base' ], array( $this, '_preview_filter' ) );
+ 					add_filter( 'default_option_' . $this->id_data[ 'base' ], array( $this, '_preview_filter' ) );
+ 				}
+ 				break;
+ 			default :
+ 				do_action( 'customize_preview_' . $this->id );
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Callback function to filter the theme mods and options.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param mixed Old value.
+ 	 * @return mixed New or old value.
+ 	 */
+ 	public function _preview_filter( $original ) {
+ 		return $this->multidimensional_replace( $original, $this->id_data[ 'keys' ], $this->post_value() );
+ 	}
+ 
+ 	/**
+ 	 * Set the value of the parameter for a specific theme.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return bool False if cap check fails or value isn't set.
+ 	 */
+ 	public final function save() {
+ 		$value = $this->post_value();
+ 
+ 		if ( ! $this->check_capabilities() || ! isset( $value ) )
+ 			return false;
+ 
+ 		do_action( 'customize_save_' . $this->id_data[ 'base' ] );
+ 
+ 		$this->update( $value );
+ 	}
+ 
+ 	/**
+ 	 * Fetches, validates, and sanitizes the $_POST value.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $default mixed A default value which is used as a fallback. Default is null.
+ 	 * @return mixed Either the default value on failure or sanitized value.
+ 	 */
+ 	public final function post_value( $default = null ) {
+ 		if ( isset( $this->_post_value ) )
+ 			return $this->_post_value;
+ 
+ 		$result = $this->manager->post_value( $this );
+ 
+ 		if ( isset( $result ) )
+ 			return $this->_post_value = $result;
+ 		else
+ 			return $default;
+ 	}
+ 
+ 	/**
+ 	 * Sanitize an input.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $value mixed The value to sanitize.
+ 	 * @return mixed Null if an input isn't valid, otherwise the sanitized value.
+ 	 */
+ 	public function sanitize( $value ) {
+ 		$value = stripslashes_deep( $value );
+ 		return apply_filters( "customize_sanitize_{$this->id}", $value, $this );
+ 	}
+ 
+ 	/**
+ 	 * Set the value of the parameter for a specific theme.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $value mixed The value to update.
+ 	 * @return mixed The result of saving the value.
+ 	 */
+ 	protected function update( $value ) {
+ 		switch( $this->type ) {
+ 			case 'theme_mod' :
+ 				return $this->_update_theme_mod( $value );
+ 				break;
+ 			case 'option' :
+ 				return $this->_update_option( $value );
+ 				break;
+ 			default :
+ 				return do_action( 'customize_update_' . $this->type, $value );
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Update the theme mod from the value of the parameter.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $value mixed The value to update.
+ 	 * @return mixed The result of saving the value.
+ 	 */
+ 	protected function _update_theme_mod( $value ) {
+ 		// Handle non-array theme mod.
+ 		if ( empty( $this->id_data[ 'keys' ] ) )
+ 			return set_theme_mod( $this->id_data[ 'base' ], $value );
+ 
+ 		// Handle array-based theme mod.
+ 		$mods = get_theme_mod( $this->id_data[ 'base' ] );
+ 		$mods = $this->multidimensional_replace( $mods, $this->id_data[ 'keys' ], $value );
+ 		if ( isset( $mods ) )
+ 			return set_theme_mod( $this->id_data[ 'base' ], $mods );
+ 	}
+ 
+ 	/**
+ 	 * Update the theme mod from the value of the parameter.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $value mixed The value to update.
+ 	 * @return mixed The result of saving the value.
+ 	 */
+ 	protected function _update_option( $value ) {
+ 		// Handle non-array option.
+ 		if ( empty( $this->id_data[ 'keys' ] ) )
+ 			return update_option( $this->id_data[ 'base' ], $value );
+ 
+ 		// Handle array-based options.
+ 		$options = get_option( $this->id_data[ 'base' ] );
+ 		$options = $this->multidimensional_replace( $options, $this->id_data[ 'keys' ], $value );
+ 		if ( isset( $options ) )
+ 			return update_option( $this->id_data[ 'base' ], $options );
+ 	}
+ 
+ 	/**
+ 	 * Fetch the value of the parameter for a specific theme.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return mixed The requested value.
+ 	 */
+ 	public function value() {
+ 		switch( $this->type ) {
+ 			case 'theme_mod' :
+ 				$function = 'get_theme_mod';
+ 				break;
+ 			case 'option' :
+ 				$function = 'get_option';
+ 				break;
+ 			default :
+ 				return apply_filters( 'customize_value_' . $this->id_data[ 'base' ], $this->default );
+ 		}
+ 
+ 		// Handle non-array value
+ 		if ( empty( $this->id_data[ 'keys' ] ) )
+ 			return $function( $this->id_data[ 'base' ], $this->default );
+ 
+ 		// Handle array-based value
+ 		$values = $function( $this->id_data[ 'base' ] );
+ 		return $this->multidimensional_get( $values, $this->id_data[ 'keys' ], $this->default );
+ 	}
+ 
+ 	/**
+ 	 * Escape the parameter's value for use in JavaScript.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return mixed The requested escaped value.
+ 	 */
+ 	public function js_value() {
+ 		$value = apply_filters( "customize_sanitize_js_{$this->id}", $this->value(), $this );
+ 
+ 		if ( is_string( $value ) )
+ 			return html_entity_decode( $value, ENT_QUOTES, 'UTF-8');
+ 
+ 		return $value;
+ 	}
+ 
+ 	/**
+ 	 * Check if the theme supports the setting and check user capabilities.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @return bool False if theme doesn't support the setting or user can't change setting, otherwise true.
+ 	 */
+ 	public final function check_capabilities() {
+ 		if ( $this->capability && ! call_user_func_array( 'current_user_can', (array) $this->capability ) )
+ 			return false;
+ 
+ 		if ( $this->theme_supports && ! call_user_func_array( 'current_theme_supports', (array) $this->theme_supports ) )
+ 			return false;
+ 
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Multidimensional helper function.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $root
+ 	 * @param $keys
+ 	 * @param bool $create Default is false.
+ 	 * @return null|array
+ 	 */
+ 	final protected function multidimensional( &$root, $keys, $create = false ) {
+ 		if ( $create && empty( $root ) )
+ 			$root = array();
+ 
+ 		if ( ! isset( $root ) || empty( $keys ) )
+ 			return;
+ 
+ 		$last = array_pop( $keys );
+ 		$node = &$root;
+ 
+ 		foreach ( $keys as $key ) {
+ 			if ( $create && ! isset( $node[ $key ] ) )
+ 				$node[ $key ] = array();
+ 
+ 			if ( ! is_array( $node ) || ! isset( $node[ $key ] ) )
+ 				return;
+ 
+ 			$node = &$node[ $key ];
+ 		}
+ 
+ 		if ( $create && ! isset( $node[ $last ] ) )
+ 			$node[ $last ] = array();
+ 
+ 		if ( ! isset( $node[ $last ] ) )
+ 			return;
+ 
+ 		return array(
+ 			'root' => &$root,
+ 			'node' => &$node,
+ 			'key'  => $last,
+ 		);
+ 	}
+ 
+ 	/**
+ 	 * Will attempt to replace a specific value in a multidimensional array.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $root
+ 	 * @param $keys
+ 	 * @param mixed $value The value to update.
+ 	 * @return
+ 	 */
+ 	final protected function multidimensional_replace( $root, $keys, $value ) {
+ 		if ( ! isset( $value ) )
+ 			return $root;
+ 		elseif ( empty( $keys ) ) // If there are no keys, we're replacing the root.
+ 			return $value;
+ 
+ 		$result = $this->multidimensional( $root, $keys, true );
+ 
+ 		if ( isset( $result ) )
+ 			$result['node'][ $result['key'] ] = $value;
+ 
+ 		return $root;
+ 	}
+ 
+ 	/**
+ 	 * Will attempt to fetch a specific value from a multidimensional array.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $root
+ 	 * @param $keys
+ 	 * @param $default A default value which is used as a fallback. Default is null.
+ 	 * @return mixed The requested value or the default value.
+ 	 */
+ 	final protected function multidimensional_get( $root, $keys, $default = null ) {
+ 		if ( empty( $keys ) ) // If there are no keys, test the root.
+ 			return isset( $root ) ? $root : $default;
+ 
+ 		$result = $this->multidimensional( $root, $keys );
+ 		return isset( $result ) ? $result['node'][ $result['key'] ] : $default;
+ 	}
+ 
+ 	/**
+ 	 * Will attempt to check if a specific value in a multidimensional array is set.
+ 	 *
+ 	 * @since 3.4.0
+ 	 *
+ 	 * @param $root
+ 	 * @param $keys
+ 	 * @return bool True if value is set, false if not.
+ 	 */
+ 	final protected function multidimensional_isset( $root, $keys ) {
+ 		$result = $this->multidimensional_get( $root, $keys );
+ 		return isset( $result );
+ 	}
+ }
+ 
+ /**
+  * A setting that is used to filter a value, but will not save the results.
+  *
+  * Results should be properly handled using another setting or callback.
+  */
+ class WP_Customize_Filter_Setting extends WP_Customize_Setting {
+ 	public function update() {}
+ }
+ 
+ /**
+  * A setting that is used to filter a value, but will not save the results.
+  *
+  * Results should be properly handled using another setting or callback.
+  */
+ final class WP_Customize_Header_Image_Setting extends WP_Customize_Setting {
+ 	public $id = 'header_image_data';
+ 
+ 	public function update( $value ) {
+ 		global $custom_image_header;
+ 
+ 		// If the value doesn't exist (removed or random),
+ 		// use the header_image value.
+ 		if ( ! $value )
+ 			$value = $this->manager->get_setting('header_image')->post_value();
+ 
+ 		if ( is_array( $value ) && isset( $value['choice'] ) )
+ 			$custom_image_header->set_header_image( $value['choice'] );
+ 		else
+ 			$custom_image_header->set_header_image( $value );
+ 	}
+ }
+ 
+ final class WP_Customize_Background_Image_Setting extends WP_Customize_Setting {
+ 	public $id = 'background_image_thumb';
+ 
+ 	public function update( $value ) {
+ 		remove_theme_mod( 'background_image_thumb' );
+ 	}
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class.wp-dependencies.php ./wordpress-3.4/wp-includes/class.wp-dependencies.php
*** ./wordpress-3.3.2/wp-includes/class.wp-dependencies.php	2011-07-28 13:24:00.000000000 -0500
--- ./wordpress-3.4/wp-includes/class.wp-dependencies.php	2011-12-13 17:45:31.000000000 -0600
***************
*** 28,34 ****
  	/**
  	 * Do the dependencies
  	 *
! 	 * Process the items passed to it or the queue.  Processes all dependencies.
  	 *
  	 * @param mixed $handles (optional) items to be processed. (void) processes queue, (string) process that item, (array of strings) process those items
  	 * @return array Items that have been processed
--- 28,34 ----
  	/**
  	 * Do the dependencies
  	 *
! 	 * Process the items passed to it or the queue. Processes all dependencies.
  	 *
  	 * @param mixed $handles (optional) items to be processed. (void) processes queue, (string) process that item, (array of strings) process those items
  	 * @return array Items that have been processed
***************
*** 63,69 ****
  	/**
  	 * Determines dependencies
  	 *
! 	 * Recursively builds array of items to process taking dependencies into account.  Does NOT catch infinite loops.
  	 *
  	 *
  	 * @param mixed $handles Accepts (string) dep name or (array of strings) dep names
--- 63,69 ----
  	/**
  	 * Determines dependencies
  	 *
! 	 * Recursively builds array of items to process taking dependencies into account. Does NOT catch infinite loops.
  	 *
  	 *
  	 * @param mixed $handles Accepts (string) dep name or (array of strings) dep names
***************
*** 90,96 ****
  			if ( !isset($this->registered[$handle]) )
  				$keep_going = false; // Script doesn't exist
  			elseif ( $this->registered[$handle]->deps && array_diff($this->registered[$handle]->deps, array_keys($this->registered)) )
! 				$keep_going = false; // Script requires deps which don't exist (not a necessary check.  efficiency?)
  			elseif ( $this->registered[$handle]->deps && !$this->all_deps( $this->registered[$handle]->deps, true, $group ) )
  				$keep_going = false; // Script requires deps which don't exist
  
--- 90,96 ----
  			if ( !isset($this->registered[$handle]) )
  				$keep_going = false; // Script doesn't exist
  			elseif ( $this->registered[$handle]->deps && array_diff($this->registered[$handle]->deps, array_keys($this->registered)) )
! 				$keep_going = false; // Script requires deps which don't exist (not a necessary check. efficiency?)
  			elseif ( $this->registered[$handle]->deps && !$this->all_deps( $this->registered[$handle]->deps, true, $group ) )
  				$keep_going = false; // Script requires deps which don't exist
  
***************
*** 98,104 ****
  				if ( $recursion )
  					return false; // Abort this branch.
  				else
! 					continue; // We're at the top level.  Move on to the next one.
  			}
  
  			if ( $queued ) // Already grobbed it and its deps
--- 98,104 ----
  				if ( $recursion )
  					return false; // Abort this branch.
  				else
! 					continue; // We're at the top level. Move on to the next one.
  			}
  
  			if ( $queued ) // Already grobbed it and its deps
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-editor.php ./wordpress-3.4/wp-includes/class-wp-editor.php
*** ./wordpress-3.3.2/wp-includes/class-wp-editor.php	2011-12-01 15:27:19.000000000 -0600
--- ./wordpress-3.4/wp-includes/class-wp-editor.php	2012-04-02 17:26:11.000000000 -0500
***************
*** 3,9 ****
   * Facilitates adding of the WordPress editor as used on the Write and Edit screens.
   *
   * @package WordPress
!  * @since 3.3
   *
   * Private, not included by default. See wp_editor() in wp-includes/general-template.php.
   */
--- 3,9 ----
   * Facilitates adding of the WordPress editor as used on the Write and Edit screens.
   *
   * @package WordPress
!  * @since 3.3.0
   *
   * Private, not included by default. See wp_editor() in wp-includes/general-template.php.
   */
***************
*** 124,130 ****
  	}
  
  	public static function editor_settings($editor_id, $set) {
! 		global $editor_styles;
  		$first_run = false;
  
  		if ( empty(self::$first_init) ) {
--- 124,130 ----
  	}
  
  	public static function editor_settings($editor_id, $set) {
! 		global $editor_styles, $post;
  		$first_run = false;
  
  		if ( empty(self::$first_init) ) {
***************
*** 167,176 ****
  				$no_captions = (bool) apply_filters( 'disable_captions', '' );
  				$plugins = array( 'inlinepopups', 'spellchecker', 'tabfocus', 'paste', 'media', 'fullscreen', 'wordpress', 'wpeditimage', 'wpgallery', 'wplink', 'wpdialogs' );
  				$first_run = true;
  
  				if ( $set['teeny'] ) {
  					self::$plugins = $plugins = apply_filters( 'teeny_mce_plugins', array('inlinepopups', 'fullscreen', 'wordpress', 'wplink', 'wpdialogs'), $editor_id );
- 					$ext_plugins = '';
  				} else {
  					/*
  					The following filter takes an associative array of external plugins for TinyMCE in the form 'plugin_name' => 'url'.
--- 167,176 ----
  				$no_captions = (bool) apply_filters( 'disable_captions', '' );
  				$plugins = array( 'inlinepopups', 'spellchecker', 'tabfocus', 'paste', 'media', 'fullscreen', 'wordpress', 'wpeditimage', 'wpgallery', 'wplink', 'wpdialogs' );
  				$first_run = true;
+ 				$ext_plugins = '';
  
  				if ( $set['teeny'] ) {
  					self::$plugins = $plugins = apply_filters( 'teeny_mce_plugins', array('inlinepopups', 'fullscreen', 'wordpress', 'wplink', 'wpdialogs'), $editor_id );
  				} else {
  					/*
  					The following filter takes an associative array of external plugins for TinyMCE in the form 'plugin_name' => 'url'.
***************
*** 181,187 ****
  					*/
  					$mce_external_plugins = apply_filters('mce_external_plugins', array());
  
- 					$ext_plugins = '';
  					if ( ! empty($mce_external_plugins) ) {
  
  						/*
--- 181,186 ----
***************
*** 247,254 ****
  
  							$ext_plugins .= 'tinyMCEPreInit.load_ext("' . $plugurl . '", "' . $mce_locale . '");' . "\n";
  							$ext_plugins .= 'tinymce.PluginManager.load("' . $name . '", "' . $url . '");' . "\n";
- 
- 							self::$ext_plugins .= $ext_plugins;
  						}
  					}
  
--- 246,251 ----
***************
*** 259,272 ****
  					$plugins[] = 'wpfullscreen';
  
  				self::$plugins = $plugins;
  
  				/*
  				The following filter allows localization scripts to change the languages displayed in the spellchecker's drop-down menu.
  				By default it uses Google's spellchecker API, but can be configured to use PSpell/ASpell if installed on the server.
! 				The + sign marks the default language. More information:
! 				http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/spellchecker
  				*/
! 				$mce_spellchecker_languages = apply_filters('mce_spellchecker_languages', '+English=en,Danish=da,Dutch=nl,Finnish=fi,French=fr,German=de,Italian=it,Polish=pl,Portuguese=pt,Spanish=es,Swedish=sv');
  
  				self::$first_init = array(
  					'mode' => 'exact',
--- 256,277 ----
  					$plugins[] = 'wpfullscreen';
  
  				self::$plugins = $plugins;
+ 				self::$ext_plugins = $ext_plugins;
+ 
+ 				/*
+ 				translators: These languages show up in the spellchecker drop-down menu, in the order specified, and with the first
+ 				language listed being the default language. They must be comma-separated and take the format of name=code, where name
+ 				is the language name (which you may internationalize), and code is a valid ISO 639 language code. Please test the
+ 				spellchecker with your values.
+ 				*/
+ 				$mce_spellchecker_languages = __( 'English=en,Danish=da,Dutch=nl,Finnish=fi,French=fr,German=de,Italian=it,Polish=pl,Portuguese=pt,Spanish=es,Swedish=sv' );
  
  				/*
  				The following filter allows localization scripts to change the languages displayed in the spellchecker's drop-down menu.
  				By default it uses Google's spellchecker API, but can be configured to use PSpell/ASpell if installed on the server.
! 				The + sign marks the default language. More: http://www.tinymce.com/wiki.php/Plugin:spellchecker.
  				*/
! 				$mce_spellchecker_languages = apply_filters( 'mce_spellchecker_languages', '+' . $mce_spellchecker_languages );
  
  				self::$first_init = array(
  					'mode' => 'exact',
***************
*** 301,315 ****
  					'convert_urls' => false,
  					'remove_linebreaks' => true,
  					'gecko_spellcheck' => true,
  					'keep_styles' => false,
  					'entities' => '38,amp,60,lt,62,gt',
  					'accessibility_focus' => true,
! 					'tabfocus_elements' => 'major-publishing-actions',
  					'media_strict' => false,
  					'paste_remove_styles' => true,
  					'paste_remove_spans' => true,
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
  					'extended_valid_elements' => 'article[*],aside[*],audio[*],canvas[*],command[*],datalist[*],details[*],embed[*],figcaption[*],figure[*],footer[*],header[*],hgroup[*],keygen[*],mark[*],meter[*],nav[*],output[*],progress[*],section[*],source[*],summary,time[*],video[*],wbr',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
--- 306,322 ----
  					'convert_urls' => false,
  					'remove_linebreaks' => true,
  					'gecko_spellcheck' => true,
+ 					'fix_list_elements' => true,
  					'keep_styles' => false,
  					'entities' => '38,amp,60,lt,62,gt',
  					'accessibility_focus' => true,
! 					'tabfocus_elements' => 'title,publish',
  					'media_strict' => false,
  					'paste_remove_styles' => true,
  					'paste_remove_spans' => true,
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
+ 					'spellchecker_rpc_url' => self::$baseurl . '/plugins/spellchecker/rpc.php',
  					'extended_valid_elements' => 'article[*],aside[*],audio[*],canvas[*],command[*],datalist[*],details[*],embed[*],figcaption[*],figure[*],footer[*],header[*],hgroup[*],keygen[*],mark[*],meter[*],nav[*],output[*],progress[*],section[*],source[*],summary,time[*],video[*],wbr',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
***************
*** 321,344 ****
  					$mce_css = array();
  					$editor_styles = array_unique($editor_styles);
  					$style_uri = get_stylesheet_directory_uri();
! 					if ( ! is_child_theme() ) {
! 						foreach ( $editor_styles as $file )
! 							$mce_css[] = "$style_uri/$file";
! 					} else {
! 						$style_dir    = get_stylesheet_directory();
  						$template_uri = get_template_directory_uri();
  						$template_dir = get_template_directory();
  
! 						foreach ( $editor_styles as $file ) {
! 							if ( file_exists( "$template_dir/$file" ) )
  								$mce_css[] = "$template_uri/$file";
  						}
  
! 						foreach ( $editor_styles as $file ) {
! 							if ( file_exists( "$style_dir/$file" ) )
! 								$mce_css[] = "$style_uri/$file";
! 						}
  					}
  					$mce_css = implode( ',', $mce_css );
  				} else {
  					$mce_css = '';
--- 328,352 ----
  					$mce_css = array();
  					$editor_styles = array_unique($editor_styles);
  					$style_uri = get_stylesheet_directory_uri();
! 					$style_dir = get_stylesheet_directory();
! 
! 					if ( is_child_theme() ) {
  						$template_uri = get_template_directory_uri();
  						$template_dir = get_template_directory();
  
! 						foreach ( $editor_styles as $key => $file ) {
! 							if ( $file && file_exists( "$template_dir/$file" ) ) {
  								$mce_css[] = "$template_uri/$file";
+ 								$editor_styles[$key] = '';
+ 							}
  						}
+ 					}
  
! 					foreach ( $editor_styles as $file ) {
! 						if ( $file && file_exists( "$style_dir/$file" ) )
! 							$mce_css[] = "$style_uri/$file";
  					}
+ 
  					$mce_css = implode( ',', $mce_css );
  				} else {
  					$mce_css = '';
***************
*** 360,365 ****
--- 368,383 ----
  				$mce_buttons_4 = apply_filters('mce_buttons_4', array(), $editor_id);
  			}
  
+ 			$body_class = $editor_id;
+ 
+ 			if ( isset($post) )
+ 				$body_class .= " post-type-$post->post_type";
+ 
+ 			if ( !empty($set['tinymce']['body_class']) ) {
+ 				$body_class .= ' ' . $set['tinymce']['body_class'];
+ 				unset($set['tinymce']['body_class']);
+ 			}
+ 
  			if ( $set['dfw'] ) {
  				// replace the first 'fullscreen' with 'wp_fullscreen'
  				if ( ($key = array_search('fullscreen', $mce_buttons)) !== false )
***************
*** 380,386 ****
  				'theme_advanced_buttons1' => implode($mce_buttons, ','),
  				'theme_advanced_buttons2' => implode($mce_buttons_2, ','),
  				'theme_advanced_buttons3' => implode($mce_buttons_3, ','),
! 				'theme_advanced_buttons4' => implode($mce_buttons_4, ',')
  			);
  
  			if ( $first_run )
--- 398,405 ----
  				'theme_advanced_buttons1' => implode($mce_buttons, ','),
  				'theme_advanced_buttons2' => implode($mce_buttons_2, ','),
  				'theme_advanced_buttons3' => implode($mce_buttons_3, ','),
! 				'theme_advanced_buttons4' => implode($mce_buttons_4, ','),
! 				'body_class' => $body_class
  			);
  
  			if ( $first_run )
***************
*** 499,511 ****
  			'language' => self::$mce_locale
  		);
  
  		do_action('before_wp_tiny_mce', self::$mce_settings);
  ?>
  
  	<script type="text/javascript">
  		tinyMCEPreInit = {
  			base : "<?php echo self::$baseurl; ?>",
! 			suffix : "",
  			query : "<?php echo $version; ?>",
  			mceInit : <?php echo $mceInit; ?>,
  			qtInit : <?php echo $qtInit; ?>,
--- 518,532 ----
  			'language' => self::$mce_locale
  		);
  
+ 		$suffix = ( defined('SCRIPT_DEBUG') && SCRIPT_DEBUG ) ? '_src' : '';
+ 
  		do_action('before_wp_tiny_mce', self::$mce_settings);
  ?>
  
  	<script type="text/javascript">
  		tinyMCEPreInit = {
  			base : "<?php echo self::$baseurl; ?>",
! 			suffix : "<?php echo $suffix; ?>",
  			query : "<?php echo $version; ?>",
  			mceInit : <?php echo $mceInit; ?>,
  			qtInit : <?php echo $qtInit; ?>,
***************
*** 575,581 ****
  		}
  
  		if ( !is_admin() )
! 			echo 'var ajaxurl = "' . admin_url('admin-ajax.php') . '";';
  ?>
  	</script>
  <?php
--- 596,602 ----
  		}
  
  		if ( !is_admin() )
! 			echo 'var ajaxurl = "' . admin_url( 'admin-ajax.php', 'relative' ) . '";';
  ?>
  	</script>
  <?php
***************
*** 597,603 ****
  		$dfw_width = get_user_setting( 'dfw_width', $width );
  		$save = isset($post->post_status) && $post->post_status == 'publish' ? __('Update') : __('Save');
  	?>
! 	<div id="wp-fullscreen-body">
  	<div id="fullscreen-topbar">
  		<div id="wp-fullscreen-toolbar">
  			<div id="wp-fullscreen-close"><a href="#" onclick="fullscreen.off();return false;"><?php _e('Exit fullscreen'); ?></a></div>
--- 618,624 ----
  		$dfw_width = get_user_setting( 'dfw_width', $width );
  		$save = isset($post->post_status) && $post->post_status == 'publish' ? __('Update') : __('Save');
  	?>
! 	<div id="wp-fullscreen-body"<?php if ( is_rtl() ) echo ' class="rtl"'; ?>>
  	<div id="fullscreen-topbar">
  		<div id="wp-fullscreen-toolbar">
  			<div id="wp-fullscreen-close"><a href="#" onclick="fullscreen.off();return false;"><?php _e('Exit fullscreen'); ?></a></div>
***************
*** 648,654 ****
  
  			<div id="wp-fullscreen-save">
  				<span><?php if ( $post->post_status == 'publish' ) _e('Updated.'); else _e('Saved.'); ?></span>
! 				<img src="images/wpspin_light.gif" alt="" />
  				<input type="button" class="button-primary" value="<?php echo $save; ?>" onclick="fullscreen.save();" />
  			</div>
  
--- 669,675 ----
  
  			<div id="wp-fullscreen-save">
  				<span><?php if ( $post->post_status == 'publish' ) _e('Updated.'); else _e('Saved.'); ?></span>
! 				<img src="<?php echo admin_url('images/wpspin_light.gif'); ?>" alt="" />
  				<input type="button" class="button-primary" value="<?php echo $save; ?>" onclick="fullscreen.save();" />
  			</div>
  
***************
*** 763,769 ****
  			<div class="link-search-wrapper">
  				<label>
  					<span><?php _e( 'Search' ); ?></span>
! 					<input type="text" id="search-field" class="link-search-field" tabindex="60" autocomplete="off" />
  					<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  				</label>
  			</div>
--- 784,790 ----
  			<div class="link-search-wrapper">
  				<label>
  					<span><?php _e( 'Search' ); ?></span>
! 					<input type="search" id="search-field" class="link-search-field" tabindex="60" autocomplete="off" />
  					<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  				</label>
  			</div>
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-error.php ./wordpress-3.4/wp-includes/class-wp-error.php
*** ./wordpress-3.3.2/wp-includes/class-wp-error.php	2011-09-03 11:02:41.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-wp-error.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 208,212 ****
  		return true;
  	return false;
  }
- 
- ?>
\ No newline at end of file
--- 208,210 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-http-ixr-client.php ./wordpress-3.4/wp-includes/class-wp-http-ixr-client.php
*** ./wordpress-3.3.2/wp-includes/class-wp-http-ixr-client.php	2011-05-14 14:45:07.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-wp-http-ixr-client.php	2012-01-08 11:01:11.000000000 -0600
***************
*** 90,93 ****
  		return true;
  	}
  }
- ?>
--- 90,92 ----
